/*This version of GogCipher is part of the GogMagog Release 4 package.
#All the files in GogMagog Release 4 are Public Domain, EXCEPT files
#under the GogCipher/ subtree.
#The GogCipher module was written by Martin Nicolay. It is freeware,
#but for legal reasons imposed by U.S regulations in 1988, the author
#specified that it is not meant for commercial use.
#If you don't like this, you can get GogMagog Release 3 which is
#100% Public Domain, or plug in your own encryption module.
#What's more, the copyright notice(s) in all files under the GogCipher/
#subtree must not be removed.
*/
/*******************************************************************************
*									       *
*	Copyright (c) Martin Nicolay,  22. Nov. 1988			       *
*									       *
*	Wenn diese (oder sinngemaess uebersetzte) Copyright-Angabe enthalten   *
*	bleibt, darf diese Source fuer jeden nichtkomerziellen Zweck weiter    *
*	verwendet werden.						       *
*									       *
*	martin@trillian.megalon.de					       *
*									       *
*******************************************************************************/

#ifndef	_arith_h_
#define	_arith_h_

#ifndef	_conf_h_
#include	"conf.h"
#endif

extern NUMBER a_one,a_two;

/*
 * Prototypes
 */

void	a_add		P(( NUMBER*, NUMBER*, NUMBER* ));
void	a_assign	P(( NUMBER*, NUMBER* ));
int	a_cmp		P(( NUMBER*, NUMBER* ));
void	a_div		P(( NUMBER*, NUMBER*, NUMBER*, NUMBER* ));
void	a_div2		P(( NUMBER* ));
void	a_ggt		P(( NUMBER*, NUMBER*, NUMBER* ));
void	a_imult		P(( NUMBER*, INT, NUMBER* ));
void	a_mult		P(( NUMBER*, NUMBER*, NUMBER* ));
void	a_sub		P(( NUMBER*, NUMBER*, NUMBER* ));
void	m_init		P(( NUMBER*, NUMBER* ));
void	m_add		P(( NUMBER*, NUMBER*, NUMBER* ));
void	m_mult		P(( NUMBER*, NUMBER*, NUMBER* ));
void	m_exp		P(( NUMBER*, NUMBER*, NUMBER* ));
int	n_bits		P(( NUMBER*, int));
void	n_div		P(( NUMBER*, NUMBER*, NUMBER*, NUMBER* ));
int	n_cmp		P(( INT*, INT*, int ));
int	n_mult		P(( INT*, INT, INT*, int ));
int	n_sub		P(( INT*, INT*, INT*, int, int ));
int	n_bitlen	P(( NUMBER* ));

#endif
